# SPDX-FileCopyrightText: Copyright (c) 2023, Linaro Limited.
#
# SPDX-FileCopyrightText: <text>Copyright 2023 Arm Limited and/or its
# affiliates <open-source-office@arm.com></text>
#
# SPDX-License-Identifier: MIT
---

{% set should_run = ('nightly' in FREQUENCY or 'weekly' in FREQUENCY or 'all' in FORCE_TESTS or 'ptest' in FORCE_TESTS.split(',')) %}

device_type: fvp
job_name: {{ CI_JOB_NAME }}

timeouts:
  connections:
    auto-login-action:
      minutes: 10
    login-action:
      minutes: 10
  job:
{% if should_run %}
    minutes: 500
{% else %}
    minutes: 60
{% endif %}
  actions:
    auto-login-action:
      minutes: 15
    fvp-deploy:
      minutes: 20
    download-retry:
      minutes: 20
    http-download:
      minutes: 20

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/corstone1000-fvp/ptest.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

priority: medium
visibility:
  group:
    - cassini

context:
  boot_character_delay: 250
  test_character_delay: 250

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: "{{ LAVA_CALLBACK_TOKEN }}"
      header: "PRIVATE-TOKEN"
      dataset: minimal

actions:
- deploy:
    to: fvp
    images:
      bl1:
        url: {{ BL1_ARTIFACT }}
      cs1000:
        url: {{ FIRMWARE_ARTIFACT }}
      extsys:
        url: {{ EXTSYS_ARTIFACT }}
      mmc0:
        url: {{ IMAGE_ARTIFACT }}
        compression: gz

- boot:
    method: fvp
    docker:
      name: "{{ CI_REGISTRY_IMAGE }}/cs1k-fvp-test-image:{{ DOCKER_IMAGE_TAG }}"
    image: /opt/models/Linux64_GCC-9.3/FVP_Corstone-1000
    version_string: 'Fast Models [^\\n]+'
    timeout:
      minutes: 20
    console_string: 'host_terminal_0: Listening for serial connection on port (?P<PORT>\d+)'
    feedbacks:
      - '(?P<NAME>host_terminal_1): Listening for serial connection on port (?P<PORT>\d+)'
      - '(?P<NAME>secenc_terminal): Listening for serial connection on port (?P<PORT>\d+)'
      - '(?P<NAME>extsys_terminal): Listening for serial connection on port (?P<PORT>\d+)'
    arguments:
      - "-C se.trustedBootROMloader.fname={BL1}"
      - "-C board.msd_mmc.p_mmc_file={MMC0}"
      - "-C extsys_harness0.extsys_flashloader.fname={EXTSYS}"
      - "-C extsys0.extsys_terminal.start_telnet=1"
      - "-C host.host_terminal_0.start_telnet=1"
      - "-C host.host_terminal_1.start_telnet=1"
      - "-C se.secenc_terminal.start_telnet=1"
      - "--data board.flash0={CS1000}@0x68000000"
    auto_login:
      login_prompt: 'corstone1000-fvp login:.*'
      username: cassini
      login_commands:
        - cassini123
        - cassini123
        - sudo su -
        - wait-online.sh eth0
    prompts:
      - 'New password: '
      - 'Re-enter new password: '
      - '@corstone1000-fvp:.+\$ '
      - '@corstone1000-fvp:.+# '
    transfer_overlay:
      download_command: wget -S
      unpack_command: tar -C / -xzf

- test:
    timeout:
{% if should_run %}
      minutes: 400
{% else %}
      minutes: 30
{% endif %}
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: cassini-integration-tests
            description: "Run Cassini integration tests"
            os:
            - oe
            scope:
            - functional
          run:
            steps:
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 600 user-accounts-integration-tests"
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 600 container-engine-integration-tests"
{% if should_run %}
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 3600 psa-arch-tests"
              - lava-test-case cassini-integration-tests --shell "sudo -HEnu test ptest-runner -t 18000 parsec-simple-e2e-tests"
{% endif %}
              - jfrog-cli config add artifactory-aws --interactive=false --artifactory-url={{ ARTIFACTORY_AWS_URL }} --user={{ ARTIFACTORY_USER }} --password={{ ARTIFACTORY_PASS }};
              - |
                cat << EOF > ./upload_spec.json
                {
                  "files": [
                    {
                      "pattern": "/home/test/runtime-integration-tests-logs/",
                      "target": "oss-cassini.lava-images-temp/ptest-runner-results/",
                      "flat": "true",
                      "recursive": "true"
                    }
                  ]
                }
                EOF
              - build_name="oss-cassini/{{ CI_PROJECT_PATH }}/{{ CI_JOB_NAME }}"
              - jfrog-cli rt upload --spec=upload_spec.json --build-name="${build_name}" --build-number="{{ CI_JOB_ID }}"
              # Collect environment variables and attach them to a build.
              - jfrog-cli rt build-collect-env "${build_name}" "{{ CI_JOB_ID }}"
              # Publish build info to Artifactory
              - jfrog-cli rt build-publish "${build_name}" "{{ CI_JOB_ID }}" --build-url="{{ CI_PROJECT_URL }}"
              # Discard builds and artifacts previously published to Artifactory
              - jfrog-cli rt build-discard "${build_name}" --max-builds=10 --delete-artifacts --async
        from: inline
        name: cassini-integration-tests
        path: inline/cassini-integration-tests.yaml

- test:
    timeout:
      minutes: 2
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: dump_upload_log
            description: '"Output Upload log"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
            - cat /home/root/.jfrog/logs/jfrog-cli.*.log || true
        from: inline
        name: output-upload-log
        path: inline/output-upload-log.yaml
